# -*- coding: utf-8 -*-

from __future__ import division

from django.conf import settings
from logit import logit

from account.models import TourGuideInfo
from utils.error.errno_utils import TourGuideStatusCode
from utils.error.response_utils import response


r = settings.REDIS_CACHE


@logit
def tourguide_submit_api(request):
    """
    导游信息提交
    :param request:
    :return:
    """
    unionid = request.POST.get('unionid', '')
    openid = request.POST.get('openid', '')
    phone = request.POST.get('phone', '')

    if TourGuideInfo.objects.filter(phone=phone).exclude(unionid=unionid).exists():
        return response(TourGuideStatusCode.TOURGUIDE_PHONE_ALREADY_EXISTS)

    fields = {
        'name': request.POST.get('name', ''),
        'sex': int(request.POST.get('sex', 1)),
        'phone': phone,
        'location': request.POST.get('location', ''),
        'no': request.POST.get('no', ''),
        'user_status': TourGuideInfo.UNVERIFIED,
    }

    tourguide, created = TourGuideInfo.objects.get_or_create(unionid=unionid, defaults=fields)
    # 状态为 UNVERIFIED 的允许修改, 其他需要登录摄影师 APP 进行信息的修改
    if tourguide.user_status not in [TourGuideInfo.UNVERIFIED, TourGuideInfo.REFUSED]:
        return response(TourGuideStatusCode.TOURGUIDE_ALREADY_NOT_UNVERIFIED)
    if not created:
        for key, value in fields.iteritems():
            setattr(tourguide, key, value)
        tourguide.save()

    return response(200, 'Submit Success', u'提交成功', {})
